Index: source/newtelligence.DasBlog.Web.Core/ActivityCore.cs
===================================================================
--- source/newtelligence.DasBlog.Web.Core/ActivityCore.cs	(revision 0)
+++ source/newtelligence.DasBlog.Web.Core/ActivityCore.cs	(revision 0)
@@ -0,0 +1,269 @@
+using System;
+using System.Web;
+using System.Web.UI;
+using System.Web.UI.WebControls;
+using System.Net.Mail;
+using System.IO;
+using System.Threading;
+using newtelligence.DasBlog.Runtime;
+using newtelligence.DasBlog.Util;
+using System.Collections;
+using newtelligence.DasBlog.Web.Core;
+
+namespace newtelligence.DasBlog.Web.Core
+{
+    public class ActivityCore
+    {
+		string configPath;
+		string contentPath;
+		string logPath;
+
+        public ActivityCore(string configPath, string contentPath, string logPath)
+		{
+			this.configPath = configPath;
+			this.contentPath = contentPath;
+			this.logPath = logPath;
+		}
+
+        public void PopulateActivities(DateTime reportDate, Hashtable referrerUrls, Hashtable userAgents, Hashtable searchUrls, Hashtable userDomains)
+        {
+
+        	SiteConfig siteConfig = SiteConfig.GetSiteConfig( configPath );
+			ILoggingDataService logService = LoggingDataServiceFactory.GetService(logPath);
+			string siteRoot = siteConfig.Root.ToUpper();
+
+			LogDataItemCollection logItems = new LogDataItemCollection();
+			logItems.AddRange(logService.GetReferralsForDay(reportDate));
+
+			foreach (LogDataItem log in logItems)
+			{
+				bool exclude = false;
+				if (log.UrlReferrer != null)
+				{
+					exclude = log.UrlReferrer.ToUpper().StartsWith(siteRoot);
+
+					// Let Utils.ParseSearchString decide whether it's a search engine referrer.
+					HyperLink link = Utils.ParseSearchString(log.UrlReferrer);
+					if (link != null)
+					{
+						string linktext = "<a href=\"" + link.NavigateUrl + "\">" + link.Text + "</a>";
+						exclude = true;
+						if (!searchUrls.Contains(linktext))
+						{
+							searchUrls[linktext] = 0;
+						}
+						searchUrls[linktext] = ((int) searchUrls[linktext]) + 1;
+					}
+				}
+
+				if (!exclude)
+				{
+					string linktext = log.UrlReferrer;
+					if (linktext.Length > 0)
+						linktext = "<a href=\"" + log.UrlReferrer + "\">" + log.UrlReferrer + "</a>";
+
+					if (!referrerUrls.Contains(linktext))
+					{
+						referrerUrls[linktext] = 0;
+					}
+
+					referrerUrls[linktext] = ((int) referrerUrls[linktext]) + 1;
+
+					log.UserAgent = HttpUtility.HtmlEncode(log.UserAgent);
+					if (!userAgents.Contains(log.UserAgent))
+					{
+						userAgents[log.UserAgent] = 0;
+					}
+
+					userAgents[log.UserAgent] = ((int) userAgents[log.UserAgent]) + 1;
+
+					log.UserDomain = HttpUtility.HtmlEncode(log.UserDomain);
+					if(!userDomains.Contains(log.UserDomain))
+					{
+						userDomains[log.UserDomain] = 0;
+					}
+
+					userDomains[log.UserDomain] = ((int) userDomains[log.UserDomain]) + 1;
+				}
+			}
+
+        }
+
+        public string GenerateSummaryTable(Hashtable searchUrls, Hashtable referrerUrls)
+        {
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+
+            sb.Append("<p>");
+            sb.Append("<table width=\"100%\">");
+            sb.Append(MakeTableHeader("Summary", "Hits"));
+            sb.Append(MakeTableRow("Internet Searches", GetTotal(searchUrls)));
+            sb.Append(MakeTableRow("Referrers", GetTotal(referrerUrls)));
+            sb.Append("</table>");
+            sb.Append("</p>");
+
+            return sb.ToString();
+        }
+
+        public string GenerateSearchesTable(Hashtable searchUrls)
+        {
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+
+            sb.Append("<p>");
+            sb.Append("<table width=\"100%\">");
+            sb.Append(MakeTableHeader("Internet Searches", "Count"));
+            sb.Append(MakeTableRowsFromArray(searchUrls));
+            sb.Append("</table>");
+            sb.Append("</p>");
+
+            return sb.ToString();
+        }
+
+        public string GenerateReferrerTable(Hashtable referrerUrls)
+        {
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+
+            sb.Append("<p>");
+            sb.Append("<table width=\"100%\">");
+            sb.Append(MakeTableHeader("Referrers", "Count"));
+            sb.Append(MakeTableRowsFromArray(referrerUrls));
+            sb.Append("</table>");
+            sb.Append("</p>");
+
+            return sb.ToString();
+        }
+
+        public string GenerateUserAgentTable(Hashtable userAgents)
+        {
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+
+            sb.Append("<p>");
+            sb.Append("<table width=\"100%\">");
+            sb.Append(MakeTableHeader("User Agents", "Count"));
+            sb.Append(MakeTableRowsFromArray(userAgents));
+            sb.Append("</table>");
+            sb.Append("</p>");
+
+            return sb.ToString();
+        }
+
+        public string GenerateUserDomainTable(Hashtable userDomains)
+        {
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+
+            sb.Append("<p>");
+            sb.Append("<table width=\"100%\">");
+            sb.Append(MakeTableHeader("User Domains", "Count"));
+            sb.Append(MakeTableRowsFromArray(userDomains));
+            sb.Append("</table>");
+            sb.Append("</p>");
+            sb.Append("<br/><br/>");
+
+            return sb.ToString();
+        }
+
+        public string GetStyleSheet()
+        {
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+            sb.Append("<style type=\"text/css\">");
+            sb.Append("table {border: 0; border-spacing: 0;	border-collapse: collapse; padding: 0;	width: 100%; font-family: Tahoma,Arial,Helvetica; font-size: 8pt; }");
+            sb.Append("td.heading { text-align: left;	font-weight: bold; color: white; background-color: #919eae;	border: 0;	padding: 10px 5px 10px 5px;}");
+            sb.Append("td.data {font-weight: normal;	border: 0; border-color: #fff #fff #abc #fff; border-style: solid; border-width: 1px;	padding: 0 5px 0 5px; }");
+            sb.Append("td.mainheader {text-align: center; font-weight: bold; color: white; background-color: #919eae; border: 0; padding: 10px 5px 10px 5px;	font-size: 16pt;}");
+            sb.Append("</style>");
+            return sb.ToString();
+        }
+
+        private string GetTotal(Hashtable hash)
+        {
+            int count = 0;
+            foreach (object key in hash.Keys)
+            {
+                count += (int)hash[key];
+            }
+            return count.ToString();
+
+        }
+
+        private string MakeTableHeader(string col1, string col2)
+        {
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+            sb.Append("<tr>");
+            sb.Append("<td class=\"heading\" width=\"90%\"><b>" + HttpUtility.HtmlEncode(col1) + "</b></td>");
+            sb.Append("<td class=\"heading\" width=\"10%\"><b>" + HttpUtility.HtmlEncode(col2) + "</b></td>");
+            sb.Append("</tr>");
+            return sb.ToString();
+        }
+
+        private string MakeTableRow(string title, string count)
+        {
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+            sb.Append("<tr>");
+
+            sb.Append("<td class=\"data\">"); // needed to split this as the doted IP is not liked 
+            sb.Append(title);                 // when adding strings together ??
+            sb.Append("</td>");               // depending on email client / SMTP server ??
+
+            sb.Append("<td class=\"data\">" + count + "</td>");
+            sb.Append("</tr>");
+            return sb.ToString();
+        }
+
+        private string MakeTableRowsFromArray(Hashtable hash)
+        {
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+
+            ArrayList arrayList = GenerateSortedItemList(hash);
+            foreach (ActivityItem ai in arrayList)
+            {
+                sb.Append(MakeTableRow(ai.Key, ai.Val.ToString()));
+            }
+
+            return sb.ToString();
+
+        }
+
+        protected ArrayList GenerateSortedItemList(IDictionary dict)
+        {
+            ArrayList listItems = new ArrayList(dict.Count);
+            foreach (DictionaryEntry de in dict)
+            {
+                listItems.Add(new ActivityItem(de.Key.ToString(), (int)de.Value));
+            }
+            listItems.Sort(new ActivityItem.Comparer());
+            return listItems;
+        }
+
+    }
+
+    class ActivityItem
+    {
+        public string Key;
+        public int Val;
+
+        public ActivityItem(string key, int val)
+        {
+            Key = key;
+            Val = val;
+        }
+
+        public class Comparer : IComparer
+        {
+            public int Compare(object left, object right)
+            {
+                int leftValue = ((ActivityItem)left).Val;
+                int rightValue = ((ActivityItem)right).Val;
+                if (leftValue > rightValue)
+                {
+                    return -1;
+                }
+                else if (leftValue < rightValue)
+                {
+                    return 1;
+                }
+                return 0;
+            }
+        }
+
+    }
+
+}
Index: source/newtelligence.DasBlog.Web.Core/newtelligence.DasBlog.Web.Core.csproj
===================================================================
--- source/newtelligence.DasBlog.Web.Core/newtelligence.DasBlog.Web.Core.csproj	(revision 707)
+++ source/newtelligence.DasBlog.Web.Core/newtelligence.DasBlog.Web.Core.csproj	(working copy)
@@ -127,6 +127,7 @@
       <Link>AssemblyInfo.cs</Link>
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="ActivityCore.cs" />
     <Compile Include="AkismetSpamBlockingService.cs">
       <SubType>Code</SubType>
     </Compile>
Index: source/newtelligence.DasBlog.Web.Core/SiteConfig.cs
===================================================================
--- source/newtelligence.DasBlog.Web.Core/SiteConfig.cs	(revision 707)
+++ source/newtelligence.DasBlog.Web.Core/SiteConfig.cs	(working copy)
@@ -1146,6 +1146,20 @@
             set { preferredBloggingAPI = value; }
         }
 
+        private string activityRssUrl = Guid.NewGuid().ToString();
+        public string ActivityRssUrl
+        {
+            get { return activityRssUrl; }
+            set { activityRssUrl = value; }
+        }
+
+        bool enableActivityRss = false;
+        public bool EnableActivityRss
+        {
+            get { return enableActivityRss; }
+            set { enableActivityRss = value; }
+        }
+
 		/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
 		/* Add new properties just above this comment*/
 		/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
Index: source/newtelligence.DasBlog.Web.Services/ActivityRssHandler.cs
===================================================================
--- source/newtelligence.DasBlog.Web.Services/ActivityRssHandler.cs	(revision 0)
+++ source/newtelligence.DasBlog.Web.Services/ActivityRssHandler.cs	(revision 0)
@@ -0,0 +1,245 @@
+using System;
+using System.Configuration;
+using System.Collections;
+using System.Collections.Specialized;
+using System.ComponentModel;
+using System.Data;
+using System.Diagnostics;
+using System.Web;
+using System.Web.Services;
+using System.Web.Services.Protocols;
+using System.Web.Services.Description;
+using System.IO;
+using System.Text;
+using System.Xml;
+using System.Xml.Serialization;
+using newtelligence.DasBlog.Runtime;
+using newtelligence.DasBlog.Web.Services.Rss20;
+using newtelligence.DasBlog.Web.Services.Atom10;
+using newtelligence.DasBlog.Web.Core;
+using newtelligence.DasBlog.Util.Html;
+
+namespace newtelligence.DasBlog.Web.Services
+{
+    class ActivityRssHandler : IHttpHandler
+    {
+        #region IHttpHandler Members
+
+        public ActivityRssHandler()
+        {
+        }
+
+        bool IHttpHandler.IsReusable
+        {
+            get { return true; }
+        }
+
+        void IHttpHandler.ProcessRequest(HttpContext context)
+        {
+            SiteConfig siteConfig = SiteConfig.GetSiteConfig();
+
+            if (!(context.Request.RawUrl.Contains(siteConfig.ActivityRssUrl)))
+            {
+                context.Response.StatusCode = 404;
+                context.Response.End();
+                return;
+            }
+
+            // must have been good
+            String XmlizedString = null;
+            MemoryStream memoryStream = new MemoryStream();
+            XmlSerializer xs = new XmlSerializer(typeof(RssRoot));
+            XmlTextWriter xmlTextWriter = new XmlTextWriter(memoryStream,Encoding.UTF8);
+            xs.Serialize(xmlTextWriter, GetActivityRss(28, 28));
+            memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
+            XmlizedString = UTF8ByteArrayToString(memoryStream.ToArray());
+            context.Response.ClearHeaders();
+            context.Response.Write(XmlizedString);
+            context.Response.ContentType = "application/rss+xml";
+            context.Response.End();
+            return;
+
+        }
+
+        #endregion
+
+        private String UTF8ByteArrayToString(Byte[] characters)
+        {
+
+            UTF8Encoding encoding = new UTF8Encoding();
+            String constructedString = encoding.GetString(characters);
+            return (constructedString);
+        }
+
+        private RssRoot GetActivityRss(int maxDayCount, int maxEntryCount)
+        {
+            SiteConfig siteConfig = SiteConfig.GetSiteConfig();
+            string activityRssUrl = Utils.GetBaseUrl(siteConfig) + siteConfig.ActivityRssUrl + @"/activityrss.ashx";
+
+            EntryCollection entries = BuildActivityEntries(maxDayCount, maxEntryCount);
+
+            RssRoot documentRoot = new RssRoot();
+            documentRoot.Namespaces.Add("dc", "http://purl.org/dc/elements/1.1/");
+
+            RssChannel ch = new RssChannel();
+            ch.Title = siteConfig.Title + " (Site Activity)";
+            if (siteConfig.Description == null || siteConfig.Description.Trim().Length == 0)
+            {
+                ch.Description = siteConfig.Subtitle;
+            }
+            else
+            {
+                ch.Description = siteConfig.Description;
+            }
+            ch.Link = activityRssUrl;
+            ch.Copyright = siteConfig.Copyright;
+            if (siteConfig.RssLanguage != null && siteConfig.RssLanguage.Length > 0)
+            {
+                ch.Language = siteConfig.RssLanguage;
+            }
+            ch.ManagingEditor = siteConfig.Contact;
+            ch.WebMaster = siteConfig.Contact;
+            ch.Image = null;
+            if (siteConfig.ChannelImageUrl != null && siteConfig.ChannelImageUrl.Trim().Length > 0)
+            {
+                ChannelImage channelImage = new ChannelImage();
+                channelImage.Title = ch.Title;
+                channelImage.Link = ch.Link;
+                if (siteConfig.ChannelImageUrl.StartsWith("http"))
+                {
+                    channelImage.Url = siteConfig.ChannelImageUrl;
+                }
+                else
+                {
+                    channelImage.Url = Utils.RelativeToRoot(siteConfig, siteConfig.ChannelImageUrl);
+                }
+                ch.Image = channelImage;
+            }
+
+            documentRoot.Channels.Add(ch);
+
+            foreach (Entry entry in entries)
+            {
+                if (entry.IsPublic == false || entry.Syndicated == false)
+                {
+                    continue;
+                }
+                XmlDocument doc2 = new XmlDocument();
+                ArrayList anyElements = new ArrayList();
+                RssItem item = new RssItem();
+                item.Title = entry.Title;
+                XmlElement dcCreator = doc2.CreateElement("dc", "creator", "http://purl.org/dc/elements/1.1/");
+                dcCreator.InnerText = siteConfig.Contact;
+                anyElements.Add(dcCreator);
+
+                item.Language = entry.Language;
+
+                //if (entry.Attachments.Count > 0)
+                //{
+                //    // RSS currently supports only a single enclsoure so we return the first one	
+                //    item.Enclosure = new Enclosure();
+                //    item.Enclosure.Url = Utils.GetEnclosureLinkUrl(entry.EntryId, entry.Attachments[0]);
+                //    item.Enclosure.Type = entry.Attachments[0].Type;
+                //    item.Enclosure.Length = entry.Attachments[0].Length.ToString();
+                //}
+
+                item.PubDate = entry.CreatedUtc.ToString("R");
+                if (ch.LastBuildDate == null || ch.LastBuildDate.Length == 0)
+                {
+                    ch.LastBuildDate = item.PubDate;
+                }
+
+
+                if (!siteConfig.AlwaysIncludeContentInRSS &&
+                    entry.Description != null &&
+                    entry.Description.Trim().Length > 0)
+                {
+                    item.Description = entry.Description;
+
+                }
+                else
+                {
+                    item.Description = ContentFormatter.FormatContentAsHTML(entry.Content);
+                    try
+                    {
+                        doc2.LoadXml(ContentFormatter.FormatContentAsXHTML(entry.Content));
+                        anyElements.Add((XmlElement)doc2.SelectSingleNode("//*[local-name() = 'body'][namespace-uri()='http://www.w3.org/1999/xhtml']"));
+                    }
+                    catch //(Exception ex)
+                    {
+                        //Debug.Write(ex.ToString());
+                        // absorb
+                    }
+                }
+
+                item.anyElements = (XmlElement[])anyElements.ToArray(typeof(XmlElement));
+                ch.Items.Add(item);
+            }
+
+            return documentRoot;
+        }
+
+        protected EntryCollection BuildActivityEntries(int maxDayCount, int maxEntryCount)
+        {
+            EntryCollection entryList = new EntryCollection();
+
+            for (int i = 1; i < maxDayCount; i++)
+            {
+                DateTime activityDate = DateTime.Now.AddDays((double)(i * -1));
+                Entry entry = BuildActivityEntryForDay(activityDate);
+                entryList.Add(entry);
+            }
+
+            entryList.Sort(new EntrySorter());
+            return entryList;
+        }
+
+        private Entry BuildActivityEntryForDay(DateTime activityDate)
+        {
+            SiteConfig siteConfig = SiteConfig.GetSiteConfig();
+
+            Entry entry = new Entry();
+            entry.AllowComments = false;
+            entry.Author = siteConfig.Contact;
+            entry.Title = "Activity : " + activityDate.ToLongDateString();
+            entry.CreatedUtc = activityDate;
+            entry.Syndicated = true;
+            entry.IsPublic = true;
+            entry.EntryId = entry.Title;
+
+            ActivityCore activityCore = new ActivityCore(SiteConfig.GetConfigFilePathFromCurrentContext(),
+                                  SiteConfig.GetContentPathFromCurrentContext(),
+                                  SiteConfig.GetLogPathFromCurrentContext());
+
+            Hashtable referrerUrls = new Hashtable();
+            Hashtable userAgents = new Hashtable();
+            Hashtable searchUrls = new Hashtable();
+            Hashtable userDomains = new Hashtable();
+
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+            sb.Append(activityCore.GetStyleSheet());
+            sb.Append("<p><table><tr><td class=\"mainheader\" width=\"100%\">Weblog Daily Activity RSS (" + activityDate.ToShortDateString() + ")</td></tr></table></p>");
+
+            try
+            {
+                activityCore.PopulateActivities(activityDate, referrerUrls, userAgents, searchUrls, userDomains);
+                sb.Append(activityCore.GenerateSummaryTable(searchUrls, referrerUrls));
+                sb.Append(activityCore.GenerateSearchesTable(searchUrls));
+                sb.Append(activityCore.GenerateReferrerTable(referrerUrls));
+                sb.Append(activityCore.GenerateUserAgentTable(userAgents));
+                sb.Append(activityCore.GenerateUserDomainTable(userDomains));
+            }
+            catch (Exception e)
+            {
+                sb.Append("<p>Error : " + e.ToString() + "</p>");
+            }
+
+            entry.Content = sb.ToString();
+
+            entry.Description = "Activity report for " + activityDate.ToLongDateString();
+
+            return entry;
+        }
+
+    }
+}
Index: source/newtelligence.DasBlog.Web.Services/newtelligence.DasBlog.Web.Services.csproj
===================================================================
--- source/newtelligence.DasBlog.Web.Services/newtelligence.DasBlog.Web.Services.csproj	(revision 707)
+++ source/newtelligence.DasBlog.Web.Services/newtelligence.DasBlog.Web.Services.csproj	(working copy)
@@ -152,6 +152,7 @@
       <Link>AssemblyInfo.cs</Link>
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="ActivityRssHandler.cs" />
     <Compile Include="AggregatorBugHandler.cs">
       <SubType>Code</SubType>
     </Compile>
@@ -250,4 +251,4 @@
     <PostBuildEvent>
     </PostBuildEvent>
   </PropertyGroup>
-</Project>
\ No newline at end of file
+</Project>
Index: source/newtelligence.DasBlog.Web.Services/ReportMailer.cs
===================================================================
--- source/newtelligence.DasBlog.Web.Services/ReportMailer.cs	(revision 707)
+++ source/newtelligence.DasBlog.Web.Services/ReportMailer.cs	(working copy)
@@ -121,114 +121,26 @@
 		}
 
 
-		private string GenerateReportEmailBody(DateTime reportDate)
+		public string GenerateReportEmailBody(DateTime reportDate)
 	    {
-			System.Text.StringBuilder sb = new System.Text.StringBuilder();
-			sb.Append(GetStyleSheet());
+            ActivityCore activityCore = new ActivityCore(configPath, contentPath, logPath);
+            Hashtable referrerUrls = new Hashtable();
+            Hashtable userAgents = new Hashtable();
+            Hashtable searchUrls = new Hashtable();
+            Hashtable userDomains = new Hashtable();
+
+            System.Text.StringBuilder sb = new System.Text.StringBuilder();
+			sb.Append(activityCore.GetStyleSheet());
 			sb.Append("<p><table><tr><td class=\"mainheader\" width=\"100%\">Weblog Daily Email Report (" + reportDate.ToLongDateString() + " UTC)</td></tr></table></p>");
 
 			try
 			{
-				Hashtable referrerUrls = new Hashtable();
-				Hashtable userAgents = new Hashtable();
-				Hashtable searchUrls = new Hashtable();
-				Hashtable userDomains = new Hashtable();
-				SiteConfig siteConfig = SiteConfig.GetSiteConfig( configPath );
-				ILoggingDataService logService = LoggingDataServiceFactory.GetService(logPath);
-				string siteRoot = siteConfig.Root.ToUpper();
-
-				LogDataItemCollection logItems = new LogDataItemCollection();
-				logItems.AddRange(logService.GetReferralsForDay(reportDate));
-
-				foreach (LogDataItem log in logItems)
-				{
-					bool exclude = false;
-					if (log.UrlReferrer != null)
-					{
-						exclude = log.UrlReferrer.ToUpper().StartsWith(siteRoot);
-
-						// Let Utils.ParseSearchString decide whether it's a search engine referrer.
-						HyperLink link = Utils.ParseSearchString(log.UrlReferrer);
-						if (link != null)
-						{
-							string linktext = "<a href=\"" + link.NavigateUrl + "\">" + link.Text + "</a>";
-							exclude = true;
-							if (!searchUrls.Contains(linktext))
-							{
-								searchUrls[linktext] = 0;
-							}
-							searchUrls[linktext] = ((int) searchUrls[linktext]) + 1;
-						}
-					}
-
-					if (!exclude)
-					{
-						string linktext = log.UrlReferrer;
-						if (linktext.Length > 0)
-							linktext = "<a href=\"" + log.UrlReferrer + "\">" + log.UrlReferrer + "</a>";
-
-						if (!referrerUrls.Contains(linktext))
-						{
-							referrerUrls[linktext] = 0;
-						}
-
-						referrerUrls[linktext] = ((int) referrerUrls[linktext]) + 1;
-
-						log.UserAgent = HttpUtility.HtmlEncode(log.UserAgent);
-						if (!userAgents.Contains(log.UserAgent))
-						{
-							userAgents[log.UserAgent] = 0;
-						}
-
-						userAgents[log.UserAgent] = ((int) userAgents[log.UserAgent]) + 1;
-
-						log.UserDomain = HttpUtility.HtmlEncode(log.UserDomain);
-						if(!userDomains.Contains(log.UserDomain))
-						{
-							userDomains[log.UserDomain] = 0;
-						}
-
-						userDomains[log.UserDomain] = ((int) userDomains[log.UserDomain]) + 1;
-					}
-				}
-
-				sb.Append("<p>");
-				sb.Append("<table width=\"100%\">");
-				sb.Append(MakeTableHeader("Summary", "Hits"));
-				sb.Append(MakeTableRow("Internet Searches", GetTotal(searchUrls)));
-				sb.Append(MakeTableRow("Referrers", GetTotal(referrerUrls) ));
-				sb.Append("</table>");
-				sb.Append("</p>");
-				
-				sb.Append("<p>");
-				sb.Append("<table width=\"100%\">");
-				sb.Append(MakeTableHeader("Internet Searches", "Count"));
-				sb.Append(MakeTableRowsFromArray(searchUrls));
-				sb.Append("</table>");
-				sb.Append("</p>");
-
-				sb.Append( "<p>");
-				sb.Append( "<table width=\"100%\">");
-				sb.Append( MakeTableHeader("Referrers", "Count"));
-				sb.Append( MakeTableRowsFromArray(referrerUrls));
-				sb.Append( "</table>");
-				sb.Append( "</p>");
-
-				sb.Append("<p>");
-				sb.Append("<table width=\"100%\">");
-				sb.Append(MakeTableHeader("User Agents", "Count"));
-				sb.Append(MakeTableRowsFromArray(userAgents));
-				sb.Append("</table>");
-				sb.Append("</p>");
-
-				sb.Append("<p>");
-				sb.Append("<table width=\"100%\">");
-				sb.Append(MakeTableHeader("User Domains", "Count"));
-				sb.Append(MakeTableRowsFromArray(userDomains));
-				sb.Append("</table>");
-				sb.Append("</p>");
-				sb.Append("<br/><br/>");
-
+                activityCore.PopulateActivities(reportDate, referrerUrls, userAgents, searchUrls, userDomains);
+                sb.Append(activityCore.GenerateSummaryTable(searchUrls, referrerUrls));
+                sb.Append(activityCore.GenerateSearchesTable(searchUrls));
+                sb.Append(activityCore.GenerateReferrerTable(referrerUrls));
+                sb.Append(activityCore.GenerateUserAgentTable(userAgents));
+                sb.Append(activityCore.GenerateUserDomainTable(userDomains));
 			}
 			catch ( Exception e)
 			{
@@ -240,115 +152,7 @@
 	    }
 
 
-		private string GetStyleSheet()
-		{
-			System.Text.StringBuilder sb = new System.Text.StringBuilder();
-			sb.Append("<style type=\"text/css\">");
-			sb.Append("table {border: 0; border-spacing: 0;	border-collapse: collapse; padding: 0;	width: 100%; font-family: Tahoma,Arial,Helvetica; font-size: 8pt; }");
-			sb.Append("td.heading { text-align: left;	font-weight: bold; color: white; background-color: #919eae;	border: 0;	padding: 10px 5px 10px 5px;}");
-			sb.Append("td.data {font-weight: normal;	border: 0; border-color: #fff #fff #abc #fff; border-style: solid; border-width: 1px;	padding: 0 5px 0 5px; }");
-			sb.Append("td.mainheader {text-align: center; font-weight: bold; color: white; background-color: #919eae; border: 0; padding: 10px 5px 10px 5px;	font-size: 16pt;}");
-			sb.Append("</style>");
-			return sb.ToString();
-		}
-
-
-		private string GetTotal(Hashtable hash)
-		{
-			int count = 0;
-			foreach (object key in hash.Keys)
-			{
-				count += (int)hash[key];
-			}
-			return count.ToString();
-
-		}
 	
-
-		private string MakeTableHeader(string col1, string col2)
-		{
-			System.Text.StringBuilder sb = new System.Text.StringBuilder();
-			sb.Append("<tr>");
-			sb.Append("<td class=\"heading\" width=\"90%\"><b>" + HttpUtility.HtmlEncode(col1) + "</b></td>");
-			sb.Append("<td class=\"heading\" width=\"10%\"><b>" + HttpUtility.HtmlEncode(col2) + "</b></td>");
-			sb.Append("</tr>");
-			return sb.ToString();
-		}
-
-
-		private string MakeTableRow(string title, string count)
-		{
-			System.Text.StringBuilder sb = new System.Text.StringBuilder();
-			sb.Append("<tr>");
-
-			sb.Append("<td class=\"data\">"); // needed to split this as the doted IP is not liked 
-			sb.Append(title);                 // when adding strings together ??
-			sb.Append("</td>");               // depending on email client / SMTP server ??
-			
-			sb.Append("<td class=\"data\">" + count + "</td>");
-			sb.Append("</tr>");
-			return sb.ToString();
-		}
-
-
-		private string MakeTableRowsFromArray(Hashtable hash)
-		{
-			System.Text.StringBuilder sb = new System.Text.StringBuilder();
-
-			ArrayList arrayList = GenerateSortedItemList(hash);
-			foreach (ActivityItem ai in arrayList)
-			{
-				sb.Append(MakeTableRow(ai.Key, ai.Val.ToString()));
-			}
-
-			return sb.ToString();
-
-		}
-
-
-		protected ArrayList GenerateSortedItemList( IDictionary dict )
-		{
-			ArrayList listItems = new ArrayList(dict.Count);
-			foreach (DictionaryEntry de in dict)
-			{
-				listItems.Add(new ActivityItem(de.Key.ToString(), (int)de.Value));
-			}
-			listItems.Sort(new ActivityItem.Comparer());
-			return listItems;
-		}
-
-	
 	}
 
-	class ActivityItem
-	{
-		public string Key;
-		public int Val;
-
-		public ActivityItem(string key, int val)
-		{
-			Key = key;
-			Val = val;
-		}
-
-		public class Comparer : IComparer
-		{
-			public int Compare(object left, object right)
-			{
-				int leftValue = ((ActivityItem)left).Val;
-				int rightValue = ((ActivityItem)right).Val;
-				if (leftValue > rightValue)
-				{
-					return -1;
-				}
-				else if (leftValue < rightValue)
-				{
-					return 1;
-				}
-				return 0;
-			}
-		}
-
-	}
-
 }
Index: source/newtelligence.DasBlog.Web/EditConfigBox.ascx
===================================================================
--- source/newtelligence.DasBlog.Web/EditConfigBox.ascx	(revision 707)
+++ source/newtelligence.DasBlog.Web/EditConfigBox.ascx	(working copy)
@@ -120,13 +120,37 @@
 					</asp:CheckBox></td>
 			</tr>
 			<tr>
-				<td class="configLabelColumnStyle" nowrap>
+				<td class="configLabelColumnStyle" nowrap style="height: 24px">
 					<asp:CheckBox ID="checkEnableAutoSave" runat="server" Text='<%# resmgr.GetString("text_config_enable_auto_save") %>' CssClass="configControlStyle">
 					</asp:CheckBox></td>
-				<td class="configLabelColumnStyle" nowrap>
+				<td class="configLabelColumnStyle" nowrap style="height: 24px">
 					<asp:CheckBox ID="checkEnableEntryReferral" runat="server" Text='<%# resmgr.GetString("text_config_enable_entry_referral") %>' CssClass="configControlStyle">
 					</asp:CheckBox></td>
 			</tr>
+			<tr>
+				<td class="configLabelColumnStyle" colspan="2">
+					<fieldset>
+						<legend>
+							<%# resmgr.GetString("text_config_activity_rss_field")%>
+						</legend>
+						<table>
+							<tr>
+								<td class="configLabelColumnStyle" style="HEIGHT: 21px; width: 374px;" nowrap colspan="2">
+									<asp:CheckBox ID="checkEnableActivityRss" runat="server" Text='<%# resmgr.GetString("text_config_enable_activityrss") %>' CssClass="configControlStyle"></asp:CheckBox>
+								</td>
+							</tr>
+							<tr>
+							    <td class="configLabelColumnStyle" nowrap>
+                                    <asp:Label ID="Label16" runat="server" Text='<%# resmgr.GetString("text_activity_rss_url")%>' CssClass="configLabelStyle"></asp:Label>
+                                </td>
+                                <td class="configLabelColumnStyle" nowrap>
+									<asp:Label ID="labelActivityRssUrl" runat="server" Text='test message' CssClass="configLabelStyle" ></asp:Label>
+                                </td>
+							</tr>
+						</table>
+					</fieldset>
+				</td>
+			</tr>
 		</table>
 	</div>
 	<div class="configSectionStyle">
